# -*- coding: utf-8 -*-

from django.contrib import admin
from django.utils.translation import ugettext_lazy as _

from .models import Language


class LanguageAdmin(admin.ModelAdmin):
    fieldsets = (
        (_('general information'), {
            'fields': ('code', 'name', 'country', 'nationality',),
        }),
    )
    search_fields = ('code', 'name')
    list_display = ('code', 'name', 'country', 'nationality',)


admin.site.register(Language, LanguageAdmin)
