from __future__ import unicode_literals

from django import template
from django.conf import settings
from django.utils.translation import get_language

register = template.Library()

def transdb(obj, name):
    lang = get_language()[0:2]
    try:
        text = getattr(obj, name)

        # DA FIXARE CON RAF
        # Il menu viene gestito in maniera vecchia, quindi ha l'oggetto
        # translation che contiene tt le sue traduzioni.
        # Quando obj e' un oggetto Template obj.translation non esiste e
        # andra' in errore (in Template l'oggetto si chiama translations)
        #
        # CASO OGGETTI MENU
        if hasattr(obj, "translation"):
            for tr in obj.translation.all():
                if tr.language.code == lang:
                    text = tr.text
                    return text
        # CASO OGGETTI TEMPLATE
        elif hasattr(obj, "translations"):
            for tr in obj.translations.all():
                if tr.language.code == lang:
                    print(tr)
                    print(name)
                    text = getattr(tr, name)
                    print(text)
                    return text
            return text
    except Exception as e:
        print(e)
        text = ''
register.simple_tag(transdb)


class GetTransDB(template.Node):
    def __init__(self, obj, name, var_name):
        self.obj = template.Variable(obj)
        self.name = name
        self.var_name = var_name
    def render(self, context):
        obj = self.obj.resolve(context)
        translate_text = transdb(obj, self.name)
        context[self.var_name] = translate_text
        return ''
def get_transdb(parser, token):
    # This version uses a regular expression to parse tag contents.
    try:
        # Splitting by None == splitting by spaces.
        tag_name, arg = token.contents.split(None, 1)
    except ValueError:
        raise template.TemplateSyntaxError("%r tag requires arguments" % token.contents.split()[0])
    obj, name, aas, var_name = arg.split(" ")
    return GetTransDB(obj, name[1:-1], var_name)
register.tag(get_transdb)


def translated(value,arg=None):
    """Removes all values of arg from the given string"""
    lang = get_language()[0:2]
    text = getattr(value, arg)
    try:
        if hasattr(value, "translations"):
            for tr in value.translations.all():
                if tr.language.code == lang:
                    text = getattr(tr, arg)
                    return text
            return text
    except Exception:
        a = 1
        text = getattr(value, arg)
register.filter('translated', translated)